<h1>Product</h1>
<div class="row mb-3">
  <div class="col">
    <a [routerLink]="['/products/new']" role="button" nbButton status="primary">NEW</a>
  </div>
</div>

<table mat-table [dataSource]="dataSource" matSort matSortActive="name" matSortDirection="asc">
  <tr mat-header-row *matHeaderRowDef="columnsToDisplay" class="first-header-row"></tr>
  <tr mat-header-row *matHeaderRowDef="filterRow" class="second-header-row"></tr>
  <tr mat-row *matRowDef="let row; columns: columnsToDisplay"></tr>

  <ng-container matColumnDef="id-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 320px"></th>
  </ng-container>

  <ng-container matColumnDef="name-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 350px">
      <mat-form-field class="filter" floatLabel="never">
        <mat-label>Search</mat-label>
        <input matInput [formControl]="nameFilterValue">
      </mat-form-field>
    </th>
  </ng-container>

  <ng-container matColumnDef="price-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 70px">
      <mat-form-field class="filter" floatLabel="never" style="width: 50px">
        <mat-label>Search</mat-label>
        <input matInput [formControl]="priceFilterValue">
      </mat-form-field>
    </th>
  </ng-container>

  <ng-container matColumnDef="description-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 300px">
      <mat-form-field class="filter" floatLabel="never">
        <mat-label>Search</mat-label>
        <input matInput [formControl]="descriptionFilterValue">
      </mat-form-field>
    </th>
  </ng-container>

  <ng-container matColumnDef="productType-filter" style="width: 200px">
    <th mat-header-cell *matHeaderCellDef>
      <mat-form-field class="filter" floatLabel="never">
        <mat-label>Search</mat-label>
        <input matInput [formControl]="productTypeFilterValue">
      </mat-form-field>
    </th>
  </ng-container>

  <ng-container matColumnDef="locked-filter">
    <th mat-header-cell *matHeaderCellDef style="width: 50px"></th>
  </ng-container>

  <ng-container matColumnDef="actions-filter">
    <th mat-header-cell *matHeaderCellDef></th>
  </ng-container>

  <ng-container matColumnDef="order-filter">
    <th mat-header-cell *matHeaderCellDef></th>
  </ng-container>

  <ng-container matColumnDef="id">
    <th mat-header-cell *matHeaderCellDef>ID</th>
    <td mat-cell *matCellDef="let row">{{row.id || '-'}}</td>
  </ng-container>

  <ng-container matColumnDef="name">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Name</th>
    <td mat-cell *matCellDef="let row">{{row.name || '-'}}</td>
  </ng-container>

  <ng-container matColumnDef="price">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Price</th>
    <td mat-cell *matCellDef="let row">{{row.price | currency}}</td>
  </ng-container>

  <ng-container matColumnDef="description">
    <th mat-header-cell *matHeaderCellDef>Description</th>
    <td mat-cell *matCellDef="let row">{{row.description}}</td>
  </ng-container>

  <ng-container matColumnDef="order">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Order</th>
    <td mat-cell *matCellDef="let row">{{row.order}}</td>
  </ng-container>

  <ng-container matColumnDef="productType">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Product Type</th>
    <td mat-cell *matCellDef="let row">{{row.productType.name}}</td>
  </ng-container>

  <ng-container matColumnDef="locked">
    <th mat-header-cell *matHeaderCellDef mat-sort-header>Locked</th>
    <td mat-cell *matCellDef="let row">
      <nb-checkbox [checked]="row.locked" [status]="row.locked ? 'danger':'success'" disabled></nb-checkbox>
    </td>
  </ng-container>

  <ng-container matColumnDef="actions">
    <th mat-header-cell *matHeaderCellDef>Actions</th>
    <td mat-cell *matCellDef="let row">
      <a nbButton ghost size="large" [routerLink]="['/products', row.id]" title="Edit">
        <nb-icon icon="edit"></nb-icon>
      </a>
    </td>
  </ng-container>

</table>
<mat-paginator [length]="dataSource.totalCount" [pageSize]="dataSource.pageSize"
               [pageSizeOptions]="[5, 10, 20, 50]" showFirstLastButtons></mat-paginator>

